/* Copyright (c) 1987, 1988, 1991, 1992  Stanley T. Shebs. */
/* This program may be used, copied, modified, and redistributed freely */
/* for noncommercial purposes, so long as this notice remains intact. */

#include "conq.h"
#include "xconq.h"

#define request_input(s,h) s->ui->modalhandler = h

Unit *
selected_unit(side)
Side *side;
{
    /* ----------------- patch by M. Campostrini, 1992 -------------------- */
    int x, y;
    Map *map;
    
    if (!sample_pointer(side, &map, &x, &y)) {
	Dprintf("selected_unit:  sample_pointer failed\n");
	return NULL;
    }
    if (map != NULL) return map->curunit;
    return NULL;
}

char *grok_string();

Unit *
current_unit(side)
Side *side;
{
    return side->ui->curunit;
}

/* Tests if state-altering commands are allowed at all. */

may_interfere(side)
Side *side;
{
    return (1 /* humanside(side) */);
}

do_find_next_mover(side, n)
Side *side;
int n;
{
#if 0
    Unit *thisunit, *unit;

    if (side->curactor) {
	thisunit = side->curactor;
    } else {
	thisunit = side->actorder;
    }
    
    if (thisunit == NULL) cmd_error(side, "no units?");
	
    unit = thisunit->act->nextactor;
    while (unit != NULL) {
	if (alive(unit) && 1 /* unit->actionsleft > 0 */) {
	    side->curactor = unit;
	    make_current(side, unit);
	    return;
	}
	unit = unit->act->nextactor;
    }
    /* Start over from the beginning. */
    unit = side->actorder;
    while (unit != thisunit) {
	if (alive(unit) && 1 /* unit->actionsleft > 0 */) {
	    side->curactor = unit;
	    make_current(side, unit);
	    return;
	}
	unit = unit->act->nextactor;
    }
    cmd_error(side, "couldn't find any besides %s to move!",
	      unit_handle(side, unit));
#endif
}

do_find_prev_mover(side, n)
Side *side;
int n;
{
    Unit *unit;

    unit = (current_unit(side) ? current_unit(side)
	    : side->unithead->prev);

    for ( ; unit != side->unithead; unit = unit->prev) { 
	if (alive(unit) && unit->side == side && unit->act->acp > 0) {
	    if (unit == current_unit(side)) {
		notify(side, "That's it!");
	    } else {
		make_current(side, unit);
	    }
	    return;
	}
    }
    cmd_error(side, "No units to move!");
}

/* Wake *everything* (that's ours) within the given radius.  Two commands */
/* actually; lowercase is transports only, uppercase is everybody. */

do_wakeup(side, n)
Side *side;
int n;
{
#if 0
    wakeup_area(side, n, TRUE);
#endif
}

/* Wake up only the main/current unit in a hex. */

do_wakemain(side, n)
Side *side;
int n;
{
#if 0
    if (current_unit(side) != NULL)
      wake_unit(current_unit(side), FALSE, WAKEFULL, (Unit *) NULL);
    wakeup_area(side, n, FALSE);
#endif
}

/* The area wakeup. */

int tmpflag;

wake_at(x, y)
int x, y;
{
    Unit *unit = unit_at(x, y);

    if (unit != NULL && (unit->side == tmpside || tmpside->designer))
	wake_unit(unit, tmpflag);
}

wakeup_area(side, n, occs)
Side *side;
int n, occs;
{
#if 0
    tmpside = side;
    tmpflag = occs;
/*    apply_to_area(side->ui->front->curx, side->ui->front->cury, n, wake_at); */
#endif
}

/* Put unit to sleep for a while.  If we sleep it next to something that */
/* might wake it up, then adjust flags so it won't wake up on next turn. */

do_sentry(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    order_sentry(unit, n);
    if (n > 1 && adj_enemy(unit))
      unit->plan->orders.flags &= ~(ENEMYWAKE|NEUTRALWAKE);
#endif
}

do_sit(side, n)
Side *side;
int n;
{
#if 0
    if (current_unit(side) != NULL) {
	do_sentry(side, current_unit(side), 1);
    } else {
	cmd_error(side, "No unit to operate on here!");
    }
#endif
}

/* Set unit to move to a given location.  */

x_moveto(side, cancel)
Side *side;
int cancel;
{
#if 0
    if (grok_position(side)) {
	if (side->ui->teach) {
	    cache_moveto(side, side->ui->reqposx, side->ui->reqposy);
	} else if (side->designer) {
	    leave_hex(side->ui->requnit);
	    enter_hex(side->ui->requnit, side->ui->reqposx, side->ui->reqposy);
/*
	    make_current(side, side->ui->requnit);
	    all_see_hex(side->ui->front->curx, side->ui->front->cury);
*/
	} else {
	    order_moveto(side->ui->requnit, side->ui->reqposx, side->ui->reqposy);
	}
	restore_cur(side);
    } else {
	request_input(side, x_moveto);
    }
#endif
}

/* The command proper. */

do_moveto(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    if (!may_interfere(side)) {
	cmd_error(side, "Hands off!");
    } else {
	ask_position(side, "Move to where?");
	side->ui->requnit = unit;
	request_input(side, x_moveto);
    }
#endif
}

/* Determine how far away another point is.  */

x_distance(side)
Side *side;
{

    if (grok_position(side)) {
      restore_cur(side);
      notify(side, "?");
    } else {
	request_input(side, x_distance);
    }
}

/* The command proper. */

do_distance(side, n)
Side *side;
int n;
{
#if 0
    ask_position(side, "Distance to where?");
    request_input(side, x_distance);
/*    side->ui->reqposx = side->ui->front->curx;  side->ui->reqposy = side->ui->front->cury;  */
#endif
}

/* Auxiliary stuff used when searching for place to return to.  Note that */
/* a good refueling spot will be woken up, so it won't get too far away */
/* before unit has a chance to get there. */
/* Won't find refueling places inside other units, sigh. */

refuel_here(x, y)
int x, y;
{
    Unit *unit;

    for_all_stack(x, y, unit) {
	/* what about allies? */
	if (unit->side == tmpside && can_carry(unit, tmpunit)) {
	    /* this should be controlled by doctrine? */
	    /* shouldn't wake up, should get a new task to "wait up"
	       or even approach if possible */
/*	    wake_unit(unit, FALSE, WAKEOWNER, NULL);  */
	    return TRUE;
	}
	/* should look at occupants too */
    }
    return FALSE;
}

/* Search for a friendly refueler within range and set course for it.  */
/* Warn player and refuse to move if nothing close enough. */

/* (Should change to be appropriate for all unit types.) */
/* search should account for different possible paths... */

do_return(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int x, y, u = unit->type, r, range = area.maxdim;

    for_all_material_types(r) {
	if (um_tomove(u, r) > 0) {
	    range = min(range, unit->supply[r] / um_tomove(u, r));
	}
    }
    tmpside = side;
    tmpunit = unit;
    if (refuel_here(unit->x, unit->y)) {
	cmd_error(side, "Already at a resupply point!");
    } else if (search_area(unit->x, unit->y, range, refuel_here, &x, &y, 1)) {
	/* needs to be a task */
	/* should tweak plan so that most efficient route chosen */
	order_moveto(unit, x, y);
    } else {
	cmd_error(side, "No resupply point in range!");
    }
}

/* The command proper just sets up the interaction. */

do_coast(side, unit, n)
Side *side;
Unit *unit;
int n;
{
}

/* Set orders to follow a leader unit. */

x_follow(side)
Side *side;
{
#if 0
    Unit *leader;

    if (grok_position(side)) {
	if ((leader = unit_at(side->ui->reqposx, side->ui->reqposy)) != NULL &&
	    leader->side == side) {
	    if (leader != side->ui->requnit) {
		if (side->ui->teach) {
		    cache_follow(side, leader, side->ui->reqvalue2);
		} else {
		    order_follow(side->ui->requnit, leader, side->ui->reqvalue2);
		}
	    } else {
		cmd_error(side, "Unit can't follow itself!");
	    }
	} else {
	    cmd_error(side, "No unit to follow!");
	}
	restore_cur(side);
    } else {
	request_input(side, x_follow);
    }
#endif
}

/* The command proper. */

do_follow(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    ask_position(side, "Which unit to follow?");
    side->ui->requnit = unit;
    request_input(side, x_follow); 
/*    side->ui->reqposx = side->ui->front->curx;  side->ui->reqposy = side->ui->front->cury;  */
    side->ui->reqvalue2 = n;
#endif
}

/* Patrolling goes back and forth between two points.  First point is the */
/* current position. */

x_patrol(side)
Side *side;
{
#if 0
    if (grok_position(side)) {
	if (side->ui->teach) {
	    cache_patrol(side, side->ui->sounit->x, side->ui->sounit->y,
			 side->ui->reqposx, side->ui->reqposy, side->ui->reqvalue2);
	} else {
	    order_patrol(side->ui->requnit, side->ui->requnit->x, side->ui->requnit->y,
			 side->ui->reqposx, side->ui->reqposy, side->ui->reqvalue2);
	}
	restore_cur(side);
    } else {
	request_input(side, x_patrol);
    }
#endif
}

/* The command proper. */

do_patrol(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    ask_position(side, "What other endpoint for patrol?");
    side->ui->requnit = unit;
    request_input(side, x_patrol);
/*    side->ui->reqposx = side->ui->front->curx;  side->ui->reqposy = side->ui->front->cury;  */
    side->ui->reqvalue2 = n;
#endif
}

/* Delay a unit's move until a later time.  The set flag will be recognized */
/* by the movement loops, when deciding which unit to move next. */

do_delay(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
  if (side->mode == MOVE) {
    side->movunit = NULL;
    notify(side, "Delaying moving %s.", unit_handle(side, unit));
  }
#endif
}

/* Get rid of unit.  Some units cannot be disbanded, but if they can, the */
/* materials go to a transport if one is there.  Disbanding a transport */
/* also disbands all the occupants - oh well. */

do_disband(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int u = unit->type;

    if (side->designer) {
	kill_unit(unit, -1);
    } else if (!may_interfere(side)) {
	cmd_error(side, "Hands off!");
    } else if (u_hp_per_disband(u) > 0) {
	if (do_disband_action(unit, unit)) {
	    notify(side, "%s goes home.", unit_handle(side, unit));
	} else {
	    /* warn about failure? */
	}
    } else {
	cmd_error(side, "You can't just get rid of the %s!", u_type_name(u));
    }
}

/* Give a unit to another side (possibly to neutrals).  Units that won't */
/* change their sides when captured won't change voluntarily either. */

/* (but giving to neutral should be tested, otherwise might kill unit) */

do_give_unit(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int u = unit->type;

    if (/* u_change_side(u) || */ side->designer) {
	unit_changes_side(unit, side_n(n), CAPTURE, PRISONER);
	all_see_hex(unit->x, unit->y);
#if 0
	if (period_setproduct()) {
	  set_product(unit, NONUTYPE);
	  unit->schedule = 0;
	} 
#endif
   } else {
	cmd_error(side, "You can't just give away the %s!", u_type_name(u));
    }
}

/* Marking is for the purpose of rearranging units within a hex. */

do_mark_unit(side, unit, n)
Side *side;
Unit *unit;
int n;
{
/*    side->markunit = unit;  */
    notify(side, "%s has been marked.", unit_handle(side, unit));
}

/* This is a clever (if I do say so myself) command to examine all occupants */
/* and suboccupants, in an inorder fashion. */

/* Should have an option to open up a list window that shows everything
   all at once. */

do_occupant(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    Unit *nextup;

    if (unit->occupant != NULL) {
	make_current(side, unit->occupant);
    } else if (unit->nexthere != NULL) {
	make_current(side, unit->nexthere);
    } else {
	nextup = unit->transport;
	if (nextup != NULL) {
	    while (nextup->transport != NULL && nextup->nexthere == NULL) {
		nextup = nextup->transport;
	    }
	    if (nextup->nexthere != NULL)
	      make_current(side, nextup->nexthere);
	    if (nextup->transport == NULL)
	      make_current(side, nextup);
	} else {
	    /* This is a no-op if there is no stacking within a hex. */
	    make_current(side, unit_at(unit->x, unit->y));
	}
    }
}

/* This can actually do general rearrangement, but defaults to putting the */
/* unit on the first available transport in the hex.  */
/* What about trying to embark a unit on itself or on its previous transp? */

do_embark(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    Unit *mainunit = unit_at(unit->x, unit->y);
    Unit *transport;

    if (side->ui->teach) {
	cache_embark(side, n);
    } else {
	if (mainunit != unit) {
#if 0
	    if (side->markunit == NULL ||
		side->markunit->x != unit->x || side->markunit->y != unit->y) {
		for_all_occupants(mainunit, transport) {
		    if (can_carry(transport, unit)) break;
		}
	    } else {
		transport = side->markunit;
	    }
#endif
	    if (transport != NULL) {
		/* needs some work... */
		transfer_unit_action(unit, unit, transport);
#if 0
		if (can_carry(transport, unit)) {
		    leave_hex(unit);
		    enter_transport(unit, transport);
		    if (n > 0) order_sentry(unit, n);
		    return TRUE;
		}
		else {
		    if (n > 0) order_embark(unit, n);
		    else cmd_error(side, "Marked unit already full.");
		}
#endif
	    } else {
		if (n > 0) order_embark(unit, n);
		else cmd_error(side, "No plausible transport!");
	    }
	} else {
	    cmd_error(side, "Nothing for this unit to get into!");
	}
	return FALSE;
    }
#endif
}

/* Give supplies to a transport.  The argument tells how many to give. */

do_give(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int something = FALSE;
    int u = unit->type, m, r, gift, actual;
    Unit *main = unit->transport;

    if (main != NULL) {
	sprintf(spbuf, "");
	m = main->type;
	for_all_material_types(r) {
	    gift = (n < 0 ? (um_storage(m, r) - main->supply[r]) : n);
	    if (gift > 0) {
		something = TRUE;
		/* Be stingy if we're low */
		if (2 * unit->supply[r] < um_storage(u, r))
		    gift = max(1, gift/2);
		actual = transfer_supply(unit, main, r, gift);
		sprintf(tmpbuf, " %d %s", actual, m_type_name(r));
		strcat(spbuf, tmpbuf);
	    }
	}
	if (something) {
	    notify(side, "%s gave%s.", unit_handle(side, unit), spbuf);
	} else {
	    notify(side, "%s gave nothing.", unit_handle(side, unit));
	}
    } else {
	cmd_error(side, "Can't transfer supplies here!");
    }
}

/* Take supplies from transport.  Both the transport must have something */
/* left. */

do_take(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    int something = FALSE;
    int u = unit->type, m, r, need, actual;
    Unit *main = unit->transport;

    if (main != NULL) {
	sprintf(spbuf, "");
	m = main->type;
	for_all_material_types(r) {
	    need = (n < 0 ? um_storage(u, r) - unit->supply[r] : n);
	    if (need > 0) {
		something = TRUE;
		/* Be stingy if we're low */
		if (2 * main->supply[r] < um_storage(m, r))
		    need = max(1, need/2);
		actual = transfer_supply(main, unit, r, need);
		sprintf(tmpbuf, " %d %s", actual, m_type_name(r));
		strcat(spbuf, tmpbuf);
	    }
	}
	if (something) {
	    notify(side, "%s got%s.", unit_handle(side, unit), spbuf);
	} else {
	    notify(side, "%s needed nothing.", unit_handle(side, unit));
	}
    } else {
	cmd_error(side, "Can't transfer supplies here!");
    }
}

/* Take the current player out of the game while letting everybody else */
/* continue on. */

ask_side()
{
}

Side *
grok_side()
{
    return NULL;
}

/* (merge with general quitting) */

x_resign_2(side)
Side *side;
{
    Side *side2 = grok_side(side);

    /* should be able to cancel from here */

    resign_game(side, side2);
}

x_resign(side)
Side *side;
{
    if (grok_bool(side)) {
	if (numsides > 2) {
	    ask_side(side, "Who do you want to surrender to?", NULL);
	    request_input(side, x_resign_2);
	} else {
	    resign_game(side, NULL);
	}
    }
}

/* Do the act of leaving the game. */

x_leave_game(side, cancel)
Side *side;
int cancel;
{
    if (cancel) return;
    if (grok_bool(side)) {
	remove_side_from_game(side);
	/* Now go back and see what happens if we're not in the game. */ 
	do_quit(side, 1);
    } else {
	/* nothing to do if we said not to exit */
    }
}

/* (Have an extra confirm for designers not to lose unsaved work??) */

x_kill_game(side, cancel)
Side *side;
int cancel;
{
    Unit *unit;
    
    if (cancel) return;
    if (grok_bool(side)) {
	exit_xconq(side);
    } else {
	/* nothing to do if we said not to exit */
    }
}

/* The exit command sets up a confirmation. */

do_quit(side, n)
Side *side;
int n;
{
    if (side->ingame) {
	if (all_others_willing_to_quit(side)) {
	    /* Everbody else is willing to get out, but confirm us anyway. */
	    ask_bool(side, "Do you really want to quit?", FALSE);
	    request_input(side, x_kill_game);
	} else {
	    if (0 /* outcome needs resolution */) {
		/* if not everybody willing to draw, then we have to resign */
		ask_bool(side, "Do you really want to give up?", FALSE);
		request_input(side, x_resign);
	    } else {
		/* Everybody is just participating. */
		ask_bool(side, "Do you want to leave this game?", FALSE);
		request_input(side, x_leave_game);
	    }
	}
    } else {
	/* We're already out of the game, not really anything to confirm. */
	if (all_others_willing_to_quit(side)) {
	    exit_xconq(side);
	} else {
	    close_display(side);
	    if (num_active_displays() == 0) {
		exit_xconq(side);
	    }
	}
    }
}

/* Stuff game state into a file.  By default, it goes into the current
   directory.  If building a scenario, we can specify just which parts
   of the game state are to be written. */

#ifdef DESIGNERS

x_save_1(side)
Side *side;
{
    char *rawcontents;
    Module *module;
    Obj *contents;

    if ((rawcontents = side->ui->answer) != NULL) {
	/* need to be able to get this name from somewhere */
	module = create_game_module("random.scn");
	/* need something better to turn contents into a Lisp object */
	contents = intern_symbol(rawcontents);
/*	interpret_content_spec(module, contents);  */
	notify(side, "File will be written to \"%s\" ...", module->filename);
	if (write_game_module(module, lispnil)) {
	    notify(side, "Done writing to \"%s\".", module->filename);
	} else {
	    cmd_error(side, "Can't open file \"%s\"!", module->filename);
	}
    } else {
	/* or assume this means to cancel the save? */
	request_input(side, x_save_1);
    }
}

#endif /* DESIGNERS */

/* Make a module appropriate to a save file, write the file, and leave. */

x_save_2(side)
Side *side;
{
    if (grok_bool(side)) {
	notify_all("Game will be saved to \"%s\" ...", savefile_name());
	if (write_entire_game_state(savefile_name())) {
	    close_displays();
	    /* this should be conditional? */
	    exit(0);
	} else {
	    cmd_error(side, "Can't open file \"%s\"!", savefile_name());
	}
    }
}

/* The command proper just sets up different modal handlers, depending on
   whether we're building (and therefore saving a scenario/fragment), or
   saving as much game state as possible, for resumption later. */

do_save(side, n)
Side *side;
int n;
{
#if 0
    Side *side2;

    /* First check to see if anybody is in the middle of doing something
       (like renaming a unit) whose state would be lost. */
    for_all_sides(side2) {
	if (side2 != side && (side2->busy
			      || (side2->ui && side2->ui->modalhandler))) {
	    cmd_error("The %s are busy doing something, can't save!",
		      plural_form(side2->name));
	}
    }
    if (side->designer) {
#ifdef DESIGNERS
	if (0) { /* interactive dialog available? */
	    /* open modal dialog to decide pieces to write */
	    /* need to be able to save parts, subareas with shifted
	       coords, etc */
	} else {
	    ask_string(side, "Types of data to save?", "everything");
	    request_input(side, x_save_1);
	}
#endif /* DESIGNERS */
    } else {
	ask_bool(side, "You really want to save?", FALSE);
	request_input(side, x_save_2);
    }
#endif
}

/* Redraw everything using the same code as when windows need a redraw. */

do_redraw(side, n)
Side *side;
int n;
{
#if 0 /* def PREVVIEW */ /* this goes on a control button */
    if (n > 0) {  /* remove the views of units likely to have moved. */
	int x, y, ts;

      for_all_hexes(x, y)
	  if (side_view_age(side, x, y) > n) {
	    int viewunit = vtype(side_view(side, x, y));

	    if (viewunit != EMPTY && viewunit != UNSEEN
		&& mobile(viewunit)) { 
	      ts = side_view_timestamp(side, x, y);
	      set_side_view(side, x, y, EMPTY);
	      side_view_timestamp(side, x, y) = ts;
	    }
	  }
    }
#endif
    recalc_caches();
    redraw(side);
}

recalc_caches()
{
    int u;
    Unit *unit;
    Side *side;

#if 0
    for_all_sides(side) {
	for_all_unit_types(u) {
	    side->units[u] = 0;
	    side->unitsbuilding[u] = 0;
	}
	for_all_side_units(side, unit) {
	    if (alive(unit)) {
		if (completed(unit)) {
		    ++(side->units[unit->type]);
		} else {
		    ++(side->unitsbuilding[unit->type]);
		}
	    }
	}
    }
#endif
}

/* Name or rename the current unit or a given side.  We make a copy of the */
/* string after it's been successfully read, just in case. */

x_name(side)
Side *side;
{
    char *name = side->ui->answer;
    Side *side2;

    if ((name = side->ui->answer) == NULL) {
	request_input(side, x_name);
    } else if (strlen(name) == 0) {
	notify(side, "Name not changed.");
    } else if (side) {
	side->name = copy_string(name);
    } else if (side->ui->requnit != NULL) {
	side->ui->requnit->name = copy_string(name);
#if 0
    } else if (side->ui->reqoside != NULL) {
	side->ui->reqoside->name = copy_string(name);
	for_all_sides(side2) show_game_state(side2);
#endif
    } else {
	cmd_error(side, "Nothing to name!");
    }
}

/* The command proper decides between unit and side naming. */

do_name(side, n)
Side *side;
int n;
{
    if (0 /* current_unit(side) != NULL */) {
	ask_string(side, "New name for unit:", current_unit(side)->name);
    } else {
	ask_string(side, "New name for yourself:", side->name);
    }
    request_input(side, x_name);
}

/* Stop the clock. */

/* (Needs some restrictions to prevent abuse.) */

do_pause(side, n)
Side *side;
int n;
{
    extern int paused;
    Side *side2;
    Map *map;

    paused = !paused;
    for_all_sides(side2) {
	for_all_maps(side2, map) {
	    show_game_state(side2, map);
	}
    }
}

x_options(side, cancel)
Side *side;
int cancel;
{
    int reinfo = FALSE, remap = FALSE, reconfig = FALSE;
    char *cmd;
    Map *map;

    if (cancel) return;
    cmd = side->ui->answer;
    if (cmd && strlen(cmd) > 0) {
	if (strcmp(cmd, "?") == 0) {
	    notify(side, "who knows anymore?");
#ifdef DESIGNERS
	} else if (strcmp(cmd, "design") == 0) {
	    /* should check password eventually - only if multi-human? */
	    if (!side->designer) {
		become_designer(side);
	    } else {
		become_nondesigner(side);
	    }
	    for_all_maps(side, map) {
		config_designer_controls(side, map);
		/* (should only update control panels and side displays?) */
		show_map(side, map);
	    }
#endif /* DESIGNERS */
#ifdef DEBUGGING
	} else if (strcmp(cmd, "D") == 0) {
#ifndef Debug
	    Debug = !Debug;
#endif
	} else if (strcmp(cmd, "DM") == 0) {
#ifndef DebugM
	    DebugM = !DebugM;
#endif
	} else if (strcmp(cmd, "DG") == 0) {
#ifndef DebugG
	    DebugG = !DebugG;
#endif
	} else if (strcmp(cmd, "invert") == 0) {
	    if (side->ui->monochrome) {
		reconfig = TRUE;
		side->ui->bonw = !side->ui->bonw;
	    } else {
		cmd_error(side, "Inverse video is only for monochrome!");
	    }
	} else if (strcmp(cmd, "mono") == 0) {
	    reconfig = TRUE;
	    side->ui->monochrome = !side->ui->monochrome;
	    side->ui->bonw = BLACKONWHITE;
#endif /* DEBUGGING */
	} else {
	    cmd_error(side, "unrecognized command \"%s\"", cmd);
	}
	if (reconfig) {
	    set_colors(side);
	    reset_color_state(side);
	    redraw(side);
	}
    } else {
	request_input(side, x_options);
    }
}

/* The command proper. */

do_options(side, n)
Side *side;
int n;
{
    ask_string(side, "Extended Command:", "");
    request_input(side, x_options);
}

/* Do some construction of new units. */

x_build(side, cancel)
Side *side;
int cancel;
{
    int u;

    if (cancel) return;
    if ((u = grok_unit_type(side)) != NONUTYPE) {

    } else {
	/* beep? */
    }
}

#if 0
	sprintf(spbuf, "%s will build: ", unit_handle(us, unit));
	ask_unit_type(side, spbuf, NULL);
	request_input(side, x_build);
#endif

do_build(side)
Side *side;
{
#if 0
    Unit *unit = NULL;

    if (0 /* !period_setproduct() */) {
	cmd_error(side, "No construction changes allowed in this game!");
    } else if (!may_interfere(side)) {
	cmd_error(side, "Hands off!");
    } else {
	/* Pick a unit. */
	unit = side->ui->closeups->unit;

	if (unit == NULL) {
	    cmd_error(side, "No unit to build with!");
	} else if (unit->side != side && !side->designer) {
	    cmd_error(side, "Not one of your units!");
	} else if (0 /* !can_build(unit) */) {
	    cmd_error(side, "This unit can't build anything!");
/*	} else if (!u_occproduce(unit->type) && unit->transport != NULL){
	    cmd_error(side, "This unit can't build anything while inside another unit!"); */
	} else {
	    /* should include side too, might not be same as unit side */
	    /* also need to disable any automated activity */
	    unit->plan->tasks = NULL;  /* hack */
	    unit->plan->awaitingorders = FALSE;
	    request_new_product(unit);
	}
    }
#endif
}

/* Setting what a unit will produce next. */

do_next_product(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    if (0 /* !period_setproduct() */) {
	cmd_error(side, "No construction changes allowed!");
    } else if (!may_interfere(side)) {
	cmd_error(side, "Hands off!");
    } else {
	if (0 /* !can_build(unit) */) {
	    cmd_error(side, "This unit can't build anything!");
/*      } else if (!u_occproduce(unit->type) && unit->transport != NULL){
	cmd_error(side, "This unit can't build anything while inside another unit!");  */
      } else {
	  /* why wakeup? */
/*	  wake_unit(unit, FALSE, WAKEOWNER, NULL);  */
/*	  request_next_product(unit);  */
      }
    }
}

#if 0
/* Just need to remember planned build. */

x_next_product_type(side)
Side *side;
{
#if 0
    int u;

    if ((u = grok_unit_type(side)) >= 0) {
	if (u != NONUTYPE) {
	    selected_unit(side)->plan->nextbuild = u;
	}
    } else {
	request_input(side, x_next_product_type);
    }
#endif
}

/* This is called when production is to be set or changed.  This
   routine allows the user to specify what will be produced after the
   current production is finished. */

request_next_product(unit)
Unit *unit;
{
    int u, uvec[MAXUTYPES];
    Side *us = unit->side;

    if (1 /* humanside(us) */) {
	for_all_unit_types(u) uvec[u] = uu_make(unit->type, u);
	sprintf(spbuf, "%s's next build will be: ", unit_handle(us, unit));
	u = ask_unit_type(us, spbuf, uvec);
	if (u < 0) {
/*	    us->ui->requnit = unit;  */
	    request_input(us, x_next_product_type);
	} else {
	    /* what to do here? */
	}
    } else {
       /* the machine should never do this.  Just ignore it.  */
    }
}
#endif

/* Set a unit to not produce anything (yes, this really is useful). */

do_idle(side, unit, n)
Side *side;
Unit *unit;
int n;
{
    if (0 /* !period_setproduct() */) {
	cmd_error(side, "No construction changes allowed!");
    } else {
    }
}

/* Send a short (1 line) message to another player.  Some messages are */
/* recognized specially, causing various actions. */

x_message(side)
Side *side;
{
#if 0
    char *msg;
    Side *side3;

    if ((msg = side->ui->answer) != NULL) {
	if (side->ui->reqoside == NULL) {
	    if (msg != NULL && strlen(msg) > 0) {
		notify_all("The %s announce: %s",
			   plural_form(side->name), msg);
	    }
	} else if (strcmp(msg, "briefing") == 0) {
	    notify(side->ui->reqoside, "Receiving a briefing from the %s...",
		   plural_form(side->name));
	    reveal_side(side, side->ui->reqoside, 100);
	    notify(side, "You just briefed the %s on your position.",
		   plural_form(side->ui->reqoside->name));
	} else if (strcmp(msg, "alliance") == 0) {
	    notify(side, "You propose a formal alliance with the %s.",
		   plural_form(side->ui->reqoside->name));
	    side->relationships[side_number(side->ui->reqoside)] = ALLY;
	    if (side->ui->reqoside->relationships[side_number(side)] >= ALLY) {
		declare_alliance(side, side->ui->reqoside);
		for_all_sides(side3) redraw(side3);
	    } else {
		notify(side->ui->reqoside, "The %s propose a formal alliance.",
		       plural_form(side->name));
	    }
	} else if (strcmp(msg, "neutral") == 0) {
	    notify(side, "You propose neutrality with the %s.",
		   plural_form(side->ui->reqoside->name));
	    side->relationships[side_number(side->ui->reqoside)] = NEUTRAL;
	    if (side->ui->reqoside->relationships[side_number(side)] == NEUTRAL) {
		declare_neutrality(side, side->ui->reqoside);
		for_all_sides(side3) redraw(side3);
	    } else {
		notify(side->ui->reqoside, "The %s propose neutrality.",
		       plural_form(side->name));
	    }
	} else if (strcmp(msg, "war") == 0) {
	    notify(side, "You declare war on the %s!",
		   plural_form(side->ui->reqoside->name));
	    declare_war(side, side->ui->reqoside);
	    for_all_sides(side3) redraw(side3);
	} else if (strlen(msg) > 0) {
	    notify(side->ui->reqoside, "The %s say to you: %s",
		   plural_form(side->name), msg);
	} else {
	    notify(side, "You keep your mouth shut.");
	}
    } else {
	request_input(side, x_message);
    }
#endif
}

/* The command proper. */

do_message(side, n)
Side *side;
int n;
{
#if 0
    char prompt[BUFSIZE];
    Side *side2;

    side2 = side_n(n);
    side->ui->reqoside = side2;
    if (side != side2) {
	if (side2) {
	    sprintf(prompt, "Say to the %s: ", plural_form(side2->name));
	} else {
	    sprintf(prompt, "Broadcast: ");
	}
	ask_string(side, prompt, (char *) NULL);
	request_input(side, x_message);
    } else {
	cmd_error(side, "You mumble to yourself.");
    }
#endif
}


/* toggle followaction flag */

do_look(side, n)
Side *side;
int n;
{
#if 0
  if (n == -1)
    side->ui->followaction = !side->ui->followaction;
  else side->ui->followaction = n;
#endif
}

/* Add a new player to the game. */
/* Should use arg to decide whether to convert machine player (or just */
/* use if available?)  Also needs to decide if new player is human and */
/* which host to open, then go through side's startup seq and open disp. */
/* Issues of cached values (?) and war/alliance setup and uses of numsides. */

do_add_player(side, n)
Side *side;
int n;
{
    notify(side, "Sorry, can't add new players yet!");
}

/* Command to display the program version. */

do_version(side)
Side *side;
{
    notify(side, "Xconq version %s", version_string());
    notify(side, "(c) %s", copyright_string());
}


#if 0
    /* gotta put it somewhere! */
    if (Debug || side->designer) reveal_side(NULL, side, 100);
#ifdef DEBUGGING
    doublecheck_state();
    reset_coverage();
    redraw(side);
#endif /* DEBUGGING */
#endif

/* Set the unit to automatic control.  */

do_auto(side, unit, n)
Side *side;
Unit *unit;
int n;
{
#if 0
    if (side->ui->teach) {
	cache_auto(side);
    } else {
        if (current_unit(side) != NULL)
	  unit->plan->orders.morder = TRUE;
    }
#endif
}

/* Commands that designers use to build stuff. */

#ifdef DESIGNERS
/* Create a unit of given type, position, and side. */

add_unit(side, x, y, u, s)
Side *side;
int x, y, u, s;
{
    Unit *unit;

    if (!side->designer) {
	cmd_error(side, "No permission to create units!");
    } else {
	if ((unit = create_unit(u)) != NULL) {
	    set_unit_side(unit, side_n(s));
	    /* Will stack, not be occupant - must move after creation */
	    enter_hex(unit, x, y);
	    init_supply(unit);
	    all_see_hex(x, y);
	}
    }
}
#if 0
set_map_curttype(side, map, t, n)
Side *side;
Map *map;
int t, n;
{
    map->curttype = t;
    show_controls(side, map);
}
#endif
/* Function to change just one hex and to echo that change. */
/* Don't need to make it show instantly, can wait. */

set_one_hex(x, y)
int x, y;
{
    set_terrain_at(x, y, tmpttype);
    see_exact(tmpside, x, y);
    update_cell_display(tmpside, x, y, FALSE);
}

/* Basic terrain painting command. */

paint_terrain(side, x, y, w2, h2, t)
Side *side;
int x, y, t;
{
    int i;

    if (!side->designer) {
	cmd_error(side, "No permission to alter terrain!");
    } else {
	tmpside = side;
	tmpttype = t;
	apply_to_hexagon(x, y, w2, h2, set_one_hex);
    }
}

#endif /* DESIGNERS */

/* The "beep trigger" is to be set only after an explicit command (should
   be per-side, ahem), controls whether a command error is noisy or not. */

int beeptrigger = FALSE;

/* Generic command error routine. */

/*VARARGS*/
cmd_error(side, control, a1, a2, a3, a4, a5, a6)
Side *side;
char *control, *a1, *a2, *a3, *a4, *a5, *a6;
{
    notify(side, control, a1, a2, a3, a4, a5, a6);
    /* Make irritating noise only when a human player both wants and
       deserves it. */
    if (beeptrigger) {
	beep(side);
    }
}

#if 0
/* The handler for unit production needs to make sure valid input has
   been received, will put in another request if not. */

x_product_type(side)
Side *side;
{
#if 0
    int u;
    Unit *unit = selected_unit(side);

    if ((u = grok_unit_type(side)) >= 0) {
	unit->action.type = A_BUILD;
	unit->action.ac1 = u;
	unit->action.ac2 = unit->x;  unit->action.ac3 = unit->y;
	/* (how do we know we can do an action right now?) */
	/* (check actionsleft?) */
	execute_action(unit);
    } else {
	request_input(side, x_product_type);
    }
#endif
}

/* This is called when production is to be set or changed.  Note that since
   the user has a pretty dull choice if there is only one possible type of
   unit to build, in such cases we can bypass requests altogether.  Also,
   don't start over if the requested unit is what was already under
   construction. */

request_new_product(unit)
Unit *unit;
{
#if 0
    int u, uvec[MAXUTYPES];
    Side *us = unit->side;

    if (1 /* humanside(us) */) {
	/* (bring up a unit closeup maybe?) */
	for_all_unit_types(u) uvec[u] = uu_make(unit->type, u);
	sprintf(spbuf, "%s will build: ", unit_handle(us, unit));
	u = ask_unit_type(us, spbuf, uvec);
	/* If we didn't get a good type, ask again. */
	if (u < 0) {
/*	    us->ui->requnit = unit;  */
	    request_input(us, x_product_type);
	} else {
	    /* If something already underway, abandon if diff type */
	    if (unit->build != NULL && unit->build->type == u) {
		notify(us, "Already building a %s, continuing",
		       u_type_name(u));
	    } else {
		/* (need explicit cancel of prev build?) */
		/* Set up the build action. */
		unit->action.type = A_BUILD;
		unit->action.ac1 = u;
		unit->action.ac2 = unit->x;  unit->action.ac3 = unit->y;
		/* Do the action (but only if actionsleft sufficient) */
		execute_action(unit);
	    }
	}
    } else {
	/* machine version? */
    }
#endif
}
#endif

do_finished(side, n)
Side *side;
int n;
{
    finish_turn(side);
}

/* This is called by the kernel to get the interface's idea of the current
   help node. */

HelpNode *
current_help_node(side)
Side *side;
{
    return side->ui->curhelpnode;
}

/* This is called by the kernel to tell the interface to set the content
   of the current help node to be the value of the string. */

set_side_help_content(side, str)
Side *side;
char *str;
{
/*    side->ui->helpstring = str;  */

    show_help(side);
}

do_help(side, n)
Side *side;
int n;
{
#if 0
    extern HelpNode *firsthelpnode;
    HelpNode *prevhelpnode = side->ui->curhelpnode;

    switch (side->ui->reqch) {
      case ' ':
	break;
      case ESCAPE:
      case 'q':
      case 'Q':
	side->ui->screenmode = normalwins;
	side->ui->mode = SURVEY;
	redraw(side);
	break;
      case 'n':
	side->ui->curhelpnode = side->ui->curhelpnode->next;
	break;
      case 'p':
	side->ui->curhelpnode = side->ui->curhelpnode->prev;
	break;
      case 'b':
	break;
      case 't':
	side->ui->curhelpnode = firsthelpnode;
	break;
      default:
	beep(side);
	break;
    }
    if (prevhelpnode != side->ui->curhelpnode) {
/*	update_help_content(side);  */
    }
#endif
    XMapWindow(side->ui->dpy, side->ui->help);
/*    show_help(side);  */
}

/* The following structure is used only for the dispatch table. */

typedef struct func_tab {
    char fchar;                 /* character to match against */
    int (*code)();              /* pointer to command's function */
    int defaultarg;             /* default for argument */
    short needunit;              /* true if cmd always applies to a unit */
    char *help;                 /* short documentation string */
} FuncTab;

/* The command table itself.  Default iterations of ITERFLAG actually turn */
/* into the value of "itertime", which can be set by options cmd. */

FuncTab commands[] = {
    's', do_sentry, ITERFLAG, TRUE, "put a unit on sentry duty",
    'w', do_wakemain, 0, FALSE, "wake units up from whatever they were doing",
    ' ', do_sit, 1, FALSE, "(Space Bar) make unit be on sentry this turn only",
    'r', do_return, 1, TRUE, "return unit to nearest city/transport",
    'd', do_delay, 1, TRUE, "delay unit's move until later in turn",
    'f', do_follow, ITERFLAG, TRUE, "follow a designated leader",
    'm', do_moveto, 1, TRUE, "move to given location",
    'a', do_occupant, 1, TRUE, "look at the occupants",
    'e', do_embark, 0, TRUE, "embark units onto transport occupying same unit",
    'x', do_mark_unit, 1, TRUE, "mark unit for later reference",
    'g', do_give, -1, TRUE, "give supplies to the transport",
    't', do_take, -1, TRUE, "take supplies from the transport",
    'o', do_options, 5, FALSE, "set various options",
    'p', do_pause, 1, FALSE, "pause the game",
    ' ', NULL, 0, 0, "",
    'P', do_build, 0, FALSE, "set/change unit production",
    'I', do_idle, ITERFLAG, TRUE, "set unit to not produce anything",
    'W', do_wakeup, 0, FALSE, "wake ALL units in area, including occupants",
    'D', do_disband, 1, TRUE, "disband a unit and send it home",
    'F', do_coast, ITERFLAG, TRUE, "follow a coastline",
    'Z', do_patrol, ITERFLAG, TRUE, "go on a patrol",
    'G', do_give_unit, -2, TRUE, "turn unit over to another side",
    'M', do_message, -2, FALSE, "send a message to other sides",
    'Q', do_quit, 1, FALSE, "get out of the game",
    'S', do_save, 1, FALSE, "save the game into a file",
/*    'A', do_add_player, 1, FALSE, "add a new player to the game", */
    'C', do_name, 1, FALSE, "call a unit or side by a name",
/*    'T', do_find_unit, -1, FALSE, "find a unit type, (arg gives unit number)", */
/*    '\024', do_find_next_unit, -1, FALSE,
           "find next unit, (arg gives unit number)", */
/*    '\004', do_next_dead, -1, FALSE, "Show next dead unit.",  */
    '?', do_help, 1, FALSE, "display help info",
/*    '/', do_ident, 1, 2, "identify things on screen", */
/*    '=', do_unit_info, 1, FALSE, "display details about a type of unit", */
    'V', do_version, 1, FALSE, "display program version",
    '\r', do_finished, 1, FALSE, "declare turn to be finished",
    '\001', do_auto, 1, TRUE, "Turn unit over to machine control",
    '\020', do_next_product, 1, TRUE, "set next product",
    '\022', do_redraw, 10, FALSE, "redraw screen erase very old views",
    '\014', do_redraw, 0, FALSE, "redraw screen",
    '\006', do_find_next_mover, -1, FALSE, "find next unit to move",
    '\002', do_find_prev_mover, -1, FALSE, "find prev unit to move",
    '\006', do_look, -1, FALSE, "look at action point when not your turn",
/*    '.', do_recenter, 1, 2, "center the screen around current location", */
    '#', do_distance, 1, FALSE, "measure the distance from the current point",
    '\0', NULL, 0, FALSE, NULL   /* end of table marker */
};

/* Search in command table and execute function if found, complaining if */
/* the command is not recognized.  Many commands operate on the "current */
/* unit", and all uniformly error out if there is no current unit, so put */
/* that test here.  Also fix up the arg if the value passed is one of the */
/* specially recognized ones. */

execute_command(side, ch, n)
Side *side;
char ch;
int n;
{
    struct func_tab *cmd;
    int x, y;
    Map *map;
    
    for (cmd = commands; cmd->fchar != '\0'; ++cmd) {
	if (ch == cmd->fchar) {
	    if (n == DFLTFLAG) n = cmd->defaultarg;
	    if (n == ITERFLAG) n = side->itertime;
	    Dprintf("... actual arg is %d\n", n);
	    switch (cmd->needunit) {
	      case 0:
		(*(cmd->code))(side, n);
		break;
	      case 1:
		if (sample_pointer(side, &map, &x, &y)
		    && map != NULL
		    && map->curunit != NULL) {
		    (*(cmd->code))(side, map->curunit, n);
		} else {
		    cmd_error(side, "No unit to operate on!");
		}
		break;
	      case 2:
		if (sample_pointer(side, &map, &x, &y)) {
		    (*(cmd->code))(side, map, x, y);
		} else {
		    cmd_error(side, "Not looking at a map!");
		}
	    }
	    return;
	}
    }
    cmd_error(side, "Unknown command '%c'", ch);
}

/* Find out if the pointer is over a hex on some map, fill in map and hex. */

sample_pointer(side, mapp, xp, yp)
Side *side;
Map **mapp;
int *xp, *yp;
{
    int x1, y1, x2, y2, dir;
    unsigned int mask;
    Map *map;
    Window w1, w2;

    for_all_maps(side, map) {
	/* ambiguity about "root window" here */
	if (XQueryPointer(side->ui->dpy, map->viewwin,
			  &w1, &w2, &x1, &y1, &x2, &y2, &mask)) {
	    deform(side, map, x2, y2, xp, yp, &dir);
	    *mapp = map;
	    printf("%d,%d -> %d,%d on map 0x%x\n", x2, y2, *xp, *yp, *mapp);
	    return TRUE;
	}
    }
    return FALSE;
}

/* Help for the main command mode just dumps part of the table, and a little */
/* extra info about what's not in the table.  This may go onto a screen or */
/* into a file, depending on where this was called from. */

describe_commands(arg, key, buf)
int arg;
char *key, *buf;
{
    FuncTab *cmd;

    for (cmd = commands; cmd->fchar != '\0'; ++cmd) {
	if (cmd->fchar < ' ' || cmd->fchar > '~') { 
	    sprintf(buf+strlen(buf), "^%c", (cmd->fchar^0x40));
	} else {
	    sprintf(buf+strlen(buf), "%c ", cmd->fchar);
	}
	sprintf(buf+strlen(buf), " %s\n", cmd->help);
    }
}
