/* Copyright (c) 1987, 1988, 1991, 1992  Stanley T. Shebs. */
/* This program may be used, copied, modified, and redistributed freely */
/* for noncommercial purposes, so long as this notice remains intact.  */

/* Help and info widget. */

#include "conq.h"
#include "xtconq.h"

set_side_help_content(side, str)
Side *side;
char *str;
{
#if 0
    int i = 0;

    XtSetArg(tmpargs[i], XtNstring, str);  ++i;
    XtSetValues(side->ui->helpinfo, tmpargs, i);

    XawTextSetInsertionPoint(side->ui->helpinfo, 0);
#endif
}

void
topics_help(w, clientdata, calldata)
Widget w;
XtPointer clientdata, calldata;
{
    Side *side = side_from_display(XtDisplay(w));

    /* should record on back chain */
    /* should enable back chain button */
    side->ui->curhelpnode = firsthelpnode;
/*    update_help_content(side);  */
}

void
previous_help(w, clientdata, calldata)
Widget w;
XtPointer clientdata, calldata;
{
    Side *side = side_from_display(XtDisplay(w));

    /* should record on back chain */
    /* should enable back chain button */
    side->ui->curhelpnode = side->ui->curhelpnode->prev;
/*    update_help_content(side);  */
}

void
next_help(w, clientdata, calldata)
Widget w;
XtPointer clientdata, calldata;
{
    Side *side = side_from_display(XtDisplay(w));

    /* should record on back chain */
    /* should enable back chain button */
    side->ui->curhelpnode = side->ui->curhelpnode->next;
/*    update_help_content(side);  */
}

/* Go back to the previous help topic. */

void
back_help(w, clientdata, calldata)
Widget w;
XtPointer clientdata, calldata;
{
    /* should pop back chain */
    /* if end of chain, disable button */
}

/* Popping down just unmaps the help window; when it comes back, the
   current help node will be whatever it was before (is this good?) */

void
cancel_help(w, clientdata, calldata)
Widget w;
XtPointer clientdata, calldata;
{
    Side *side = side_from_display(XtDisplay(w));

    XtPopdown(side->ui->help);
}

/* Create a window where documentation-type info will go. */

/* (Need a button to print the info about a topic.) */

create_help_window(side)
Side *side;
{
    int i, wid, hgt;
    Widget helpshell, help, helpstuff, tmpwidget;

    helpshell =
      XtCreatePopupShell("Help", topLevelShellWidgetClass,
			 toplevel(side), NULL, 0);
    i = 0;
    XtSetArg(tmpargs[i], XtNwidth, 600);  ++i;
    XtSetArg(tmpargs[i], XtNheight, 650);  ++i;
    help =
      XtCreateManagedWidget("box", boxWidgetClass,
			    helpshell, tmpargs, i);
    i = 0;
    XtSetArg(tmpargs[i], XtNstring, "(nothing)");  ++i;
    XtSetArg(tmpargs[i], XtNwidth, 580);  ++i;
    XtSetArg(tmpargs[i], XtNheight, 700);  ++i;
/* how to get the scroll bar? */
/*    XtSetArg(tmpargs[i], XtNtextOptions, scrollVertical);  ++i;  */
    helpstuff =
      XtCreateManagedWidget("HelpContent", asciiTextWidgetClass,
			    help, tmpargs, i);
    i = 0;
    XtSetArg(tmpargs[i], XtNlabel, "Topics");  ++i;
    tmpwidget =
      XtCreateManagedWidget("topics", commandWidgetClass, help, tmpargs, i);
    XtAddCallback(tmpwidget, XtNcallback, topics_help, NULL);
    i = 0;
    XtSetArg(tmpargs[i], XtNlabel, "Previous");  ++i;
    tmpwidget =
      XtCreateManagedWidget("previous", commandWidgetClass, help, tmpargs, i);
    XtAddCallback(tmpwidget, XtNcallback, previous_help, NULL);
    i = 0;
    XtSetArg(tmpargs[i], XtNlabel, "Next");  ++i;
    tmpwidget =
      XtCreateManagedWidget("next", commandWidgetClass, help, tmpargs, i);
    XtAddCallback(tmpwidget, XtNcallback, next_help, NULL);
    i = 0;
    XtSetArg(tmpargs[i], XtNlabel, "Back");  ++i;
    XtSetArg(tmpargs[i], XtNsensitive, False);  ++i;  /* initially */
    tmpwidget =
      XtCreateManagedWidget("back", commandWidgetClass, help, tmpargs, i);
    XtAddCallback(tmpwidget, XtNcallback, back_help, NULL);
    i = 0;
    XtSetArg(tmpargs[i], XtNlabel, "Cancel");  ++i;
    tmpwidget =
      XtCreateManagedWidget("cancel", commandWidgetClass, help, tmpargs, i);
    XtAddCallback(tmpwidget, XtNcallback, cancel_help, NULL);
    side->ui->help = helpshell;
    side->ui->helpinfo = helpstuff;
}

/* Popup the help window. */

reveal_help(side)
Side *side;
{
    extern HelpNode *firsthelpnode;

    if (side->ui->curhelpnode == NULL) {
	side->ui->curhelpnode = firsthelpnode;
    }
    XtPopup(side->ui->help, XtGrabNone);
    /* Do we really need to wait until after popup? */
/*    update_help_content(side);  */
}

HelpNode *
current_help_node(side)
Side *side;
{
    return side->ui->curhelpnode;
}
